;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;DIALOG EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jamas {
  title "Away System"
  size -1 -1 107 86
  option dbu
  icon $dialog.icon , 0
  text "Away Type:", 1, 4 6 30 8
  radio "Normal", 2, 42 5 27 10
  radio "Silent", 3, 79 5 23 10
  text "Text Color:", 4, 4 23 27 8
  combo 5, 32 20 17 50, size drop
  text "Bracket Color:", 6, 51 23 35 8
  combo 7, 87 20 17 50, size drop
  text "Msg:", 8, 5 40 12 8
  combo 9, 19 37 85 50, size drop
  button "Add", 10, 31 52 15 8
  button "Del", 11, 47 52 15 8
  button "Edit", 12, 63 52 15 8
  edit "", 13, 4 63 100 8, autohs center
  button "?", 14, 39 75 15 8
  button "X", 16, 55 75 15 8, cancel
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias as.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 1,2,3,4,6,8 textbg $dialog.color
  dll $mdx SetColor 1,2,3,4,6,8 background $dialog.color
}
alias as.t.c.a {
  dll $mdx SetColor 1,2,3,4,5,6,7,8,9,13 text $text.color
}
alias as.el.c.a {
  dll $mdx SetColor 5,7,9,13 background $edit.list.color
  dll $mdx SetColor 5,7,9,13 textbg $edit.list.color
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias jamas { if (!$dialog(jamas)) { dialog -m jamas jamas } | else { dialog -ve jamas } }
alias away.path { return $+(",$scriptdirhashtables\awaymsgs.am,")  }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias a.add.bracket {   
  var %sel = $did($dname,$did).sel
  dec %sel 2
  hadd system awaytextcolor %sel
  system.update
}
alias a.add.text {
  var %sel = $did($dname,$did).sel
  dec %sel 2
  hadd system awaybracketcolor %sel
  system.update
}
alias a.t.c { return $chr(3) $+ $hget(system,textcolor) }
alias a.b.c.l { return $chr(3) $+ $hget(system,bracketcolor) $+ [ }
alias a.b.c.r { return $chr(3) $+ $hget(system,bracketcolor) $+ ] }
alias a.b.c { return $chr(3) $+ $hget(system,bracketcolor) }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;MESSAGE ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.msgs {
  did -r jamas 9
  var %i = 1
  while ( $read($away.path,%i) ) {
    var %msg = $ifmatch
    did -a jamas 9 %msg
    inc %i
  }
}
alias a.add.msg { 
  write $away.path $did(13).text
  did -r jamas 13
  get.msgs
  var %x = $hget(system,away.sel)
  did -c jamas 9 %x
}
alias a.del.msg {
  var %line = $did(jamas,9).sel
  write -dl $+ %line $away.path 
  get.msgs
  var %x = $hget(system,away.sel)
  dec %x
  did -c jamas 9 %x
}
alias a.edit.msg {
  var %line = $did(jamas,9).seltext
  did -a jamas 13 %line
  var %no = $did(jamas,9).sel
  write -dl $+ %no $away.path 
  get.msgs
  var %x = $hget(system,away.sel)
  dec %x
  did -c jamas 9 %x
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;AWAY TIME ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias check.time {
  if ( %away.time == $null ) { set %away.time 0 }
  inc %away.time
}
alias work.time {
  var %time = %away.time
  var %length = $duration(%away.time)
  return %length
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;GOING AWAY ALIASE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias daway {
  if ( $hget(system,away.type) == normal ) {
    if ( $hget(system,away.msg) == $null ) { echo -a ERROR: No Away Message set }
    else {
      away $hget(system,away.msg)
      amsg $a.b.c.l $+ $.a.t.c $+ AWAY $+ $a.b.c.r $a.b.c.l $+ $a.t.c $+ MSG: $hget(system,away.msg) $+ $a.b.c.r $a.b.c.l $+ $a.t.c TIME: $time $+ $a.b.c.r
      .timerawaytime 0 1 check.time
    }
  }
  if ( $hget(system,away.type) == silent ) { 
    if ( $hget(system,away.msg) == $null ) { echo -a ERROR: No Away Message set }
    else {
      away $hget(system,away.msg)
      .timerawaytime 0 1 check.time
    }
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.as.help {
  var %as.path = $remove($+(",$scriptdirHelp\Away System\awaysystem.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%as.path) 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COMING BACK ALIASE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias dback {
  if ( $hget(system,away.type) == normal ) {
    away 
    amsg $a.b.c.l $+ $.a.t.c $+ BACK $+ $a.b.c.r $a.b.c.l $+ $a.t.c $+ MSG: $hget(system,away.msg) $+ $a.b.c.r $a.b.c.l $+ $a.t.c $+ WAS AWAY FOR: $work.time $+ $a.b.c.r
    .timerawaytime off
    unset %away.time
  }
  if ( $hget(system,away.type) == silent ) { 
    away
    .timerawaytime off
    .timer $+ $rand(1,99999) 1 5 unset %away.time
  }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;INIT EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamas:init:0:{
  mdx.init
  dll $mdx SetBorderStyle $dname 10,11,12,14,16 style $hget(system,button.style)
  dll $mdx SetBorderStyle $dname 13 style $hget(system,border.style)
  dll $mdx SetFont $dname 1,2,3,4,5,6,7,8,9,10,11,12,13,14,16 -10 400 $hget(system,font.style)
  dll $combo COMBO $dname 5
  dll $combo COMBO $dname 7
  get.msgs
  var %x = $hget(system,away.sel)
  did -c jamas 9 %x
  var %first = $hget(system,awaytextcolor)
  var %last = $hget(system,awaybracketcolor)
  inc %first 2 | inc %last 2 
  did -c jamas 5 %first
  did -c jamas 7 %last
  var %i = $hget(system,away.type)
  if ( %i == normal ) { did -c jamas 2 }
  elseif ( %i == silent ) { did -c jamas 3 }
  if ( $hget(system,d.c) == on ) { as.d.c.a }
  if ( $hget(system,t.c) == on ) { as.t.c.a }
  if ( $hget(system,e.l.c) == on ) { as.el.c.a }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICK EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jamas:sclick:*:{
  if ( $did == 2 ) { if ( $did(2).state == 1 ) { hadd system away.type normal | system.update } }
  if ( $did == 3 ) { if ( $did(3).state == 1 ) { hadd system away.type silent | system.update } }
  if ( $did == 5 ) { a.add.text }
  if ( $did == 7 ) { a.add.bracket }
  if ( $did == 9 ) { hadd system away.sel $did(jamas,9).sel | hadd system away.msg $did(jamas,9).seltext | system.update }
  if ( $did == 10 ) { a.add.msg }
  if ( $did == 11 ) { a.del.msg }
  if ( $did == 12 ) { a.edit.msg }
  if ( $did == 14 ) { get.as.help } 
  if ( $did == 16 ) { window -c @help | system.update }
}
