Move Up:{ pic.up }
Move Down:{ pic.down }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;MAIN DIALOG
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog jampv {
  title "Picture Viewer"
  size -1 -1 208 68
  option dbu
  icon $dialog.icon , 0
  tab "source", 1, -8 -16 219 158   
  list 5, 59 3 146 47, tab 1 size    
  button "Add", 6, 108 55 15 8, tab 1
  button "Del", 7, 124 55 15 8, tab 1
  button "List", 18, 140 55 15 8, tab 1
  tab "list", 10
  list 11, 119 20 85 35, tab 10 size
  text "Viewing:", 12, 58 5 22 8, tab 10
  edit "", 13, 79 3 125 8, tab 10 read autohs
  button "View", 17, 166 57 15 8, tab 10
  text "View Type:", 21, 58 27 28 8, tab 10
  check "Small", 22, 90 25 26 10, tab 10
  check "Large", 23, 90 37 26 10, tab 10
  button "?", 3, 13 57 15 8
  button "X", 4, 29 57 15 8, cancel
  list 2, 3 3 50 50, size      
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;OPENING DIALOG ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias jampv { if (!$dialog(jampv)) { dialog -m jampv jampv } | else { dialog -ve jampv } }
alias pv.sv { if (!$dialog(pv.sv)) { dialog -m pv.sv pv.sv } | else { dialog -ve pv.sv } }
alias pv.lv { if (!$dialog(pv.lv)) { dialog -m pv.lv pv.lv } | else { dialog -ve pv.lv } }
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SMALL DIALOG
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog pv.sv {
  title "Small View"
  size -1 -1 250 198
  option pixels
  icon $dialog.icon , 0
  icon 1, 0 10 250 188, $current.view

}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;LARGE DIALOG
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
dialog pv.lv {
  title "Large View"
  size -1 -1 $window(-1).w $window(-1).h
  option pixels
  icon $dialog.icon , 0
  icon 1, 0 0 $window(-1).w $window(-1).h , $current.view
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;VIEWING PIC ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias current.view {
  var %file = $hget(system,last.pic) 
  return %file
}
alias view.p {
  var %source = $+(",$did(jampv,13).text,")
  var %file = $did(jampv,11).seltext
  var %pic = $findfile(%source,%file,1) 
  hadd system last.pic %pic
  system.update
  var %view = $hget(system,pic.type)
  if ( %view == small ) { small.view }
  elseif ( %view == large ) { large.view }
}
alias small.view { 
  if (!$dialog(pv.sv)) { dialog -m pv.sv pv.sv } 
  else { did -g pv.sv 1 $+(",$hget(system,last.pic),") } 
} 
alias large.view {   
  if (!$dialog(pv.lv)) { dialog -m pv.lv pv.lv } 
  else { did -g pv.lv 1 $+(",$hget(system,last.pic),") } 
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HASH ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias pic.hash.make {  
  hmake picture
  hload -i picture $+(",$scriptdirhashtables\picture.hsh,")
}
alias pic.hash.save { 
  hsave -io picture $+(",$scriptdirhashtables\picture.hsh,") 
  hfree picture
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;COLOR ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias pv.d.c.a {
  dll $mdx SetDialog $dname bgcolor $dialog.color
  dll $mdx SetColor 12,21,22,23 textbg $dialog.color
  dll $mdx SetColor 12,21,22,23 background $dialog.color
}
alias pv.t.c.a {
  dll $mdx SetColor 12,21 text $text.color
  did -i $dname 2 1 setcolor text $text.color
  did -i $dname 2 1 setcolor line $text.color
  did -i $dname 2 1 settxt color $text.color
}
alias pv.el.c.a {         
  dll $mdx SetColor 11,13 background $edit.list.color
  dll $mdx SetColor 11,13 textbg $edit.list.color
  did -i $dname 2 1 setcolor bkg $edit.list.color
  did -i $dname 5 1 settxt bgcolor $edit.list.color
  did -i $dname 5 1 setbkg color $edit.list.color  
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;HELP ALIAS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias get.pv.help {
  var %si.path = $remove($+(",$scriptdirHelp\Picture Viewer\pictureviewer.htm,"),$chr(34))
  window -ak(0) @Help 
  echo @Help $dll($nHTMLn,attach,$window(@Help).hwnd) 
  echo @Help $dll($nHTMLn,navigate,%si.path) 
}
alias pic.down {
  var %pp = $did(jampv,11).sel
  if (%pp == $did(jampv,11).lines) { halt }
  else { var %pp = $calc($did(jampv,11).sel + 1) }
  did -c jampv 11 %pp
  view.p
}
alias pic.up {
  var %pp = $did(jampv,11).sel
  if (%pp == $did(jampv,11).lines) { halt }
  else { var %pp = $calc($did(jampv,11).sel - 1) }
  did -c jampv 11 %pp
  view.p
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SOURCE ALIASES
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
alias popread { return $dll($+(",$scriptdirdlls/popread.dll,"),popread,$script? $$1 ? $$2 ? $calc($mouse.dx - 24) ? $mouse.dy ) }
alias add.p.s {
  var %i = $sdir="Enter Source Dir"
  if ( $chr(32) isin %i ) { var %i = $replace(%i,$chr(32),$chr(45)) }
  var %count = $hget(picture,0).item
  inc %count
  hadd picture %count %i
  list.p.f
}
alias del.p.s {
  var %sel = $gettok($did(jampv,5).seltext,6-,32)
  var %sel.final = $gettok(%sel,1,32)
  var %i = 1
  while ( $hget(picture,%i).data ) {
    var %item = $hget(picture,%i).item
    var %source = $gettok($v1,1,32)
    if ( %source == %sel.final ) { hdel picture %item }
    inc %i
  }
  list.p.f
}
alias list.p.f {
  did -r jampv 5
  var %i = 1
  while ( $hget(picture,%i).data ) {
    var %source = $gettok($v1,1,32)
    var %number = $gettok($v1,2,32)
    if ( %number == $null ) { var %number = N/A }
    did -a jampv 5 %source $chr(9) %number
    inc %i
  }
}
alias p.list.f {
  var %source = $gettok($did(jampv,5).seltext,6-,32)
  var %p.source = $replace($remove($gettok(%source,1,32),0,+fs),$chr(45),$chr(32))
  did -ra jampv 13 %p.source
  did -f jampv 10
  did -r jampv 11
  var %jpg = $findfile(%p.source,*.jpg,0, did -a jampv 11 $nopath($1-)  ) 
  var %total = %jpg
  var %jpeg = $findfile(%p.source,*.jpeg,0, did -a jampv 11 $nopath($1-) ) 
  inc %total %jpeg
  var %bmp = $findfile(%p.source,*.bmp,0, did -a jampv 11 $nopath($1-) )
  inc %total %bmp
  var %png = $findfile(%p.source,*.png,0, did -a jampv 11 $nopath($1-)  )
  inc %total %png
  var %ico = $findfile(%p.source,*.ico,0, did -a jampv 11 $nopath($1-)  )
  inc %total %ico
  var %f.total = %total
  var %i = 1
  while ( $hget(picture,%i).data ) {
    var %info = $gettok($v1,1,32), %number = $hget(picture,%i).item
    if ( $replace(%info,$chr(45),$chr(32)) == %p.source ) { hadd picture %number %info %f.total }
    inc %i
  }
  list.p.f
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ON INIT EVENT (SMALL DIALOG)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:pv.sv:init:0:{
  mdx.init
  dll $mdx SetBorderStyle $dname 1 style $hget(system,border.style)
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ON INIT EVENT (LARGE DIALOG)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:pv.lv:init:0:{
  mdx.init
  dll $mdx SetBorderStyle $dname 1 style $hget(system,border.style)
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;ON INIT EVENT (MAIN DIALOG)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:jampv:init:0:{
  mdx.init
  pic.hash.make
  dll $mdx SetControlMDX $dname 2 TreeView haslines linesatroot hasbuttons > $scriptdirdlls\views.mdx
  did -a $dname 2 +eb Options
  did -i $dname 2 1 cb root last 1
  did -a $dname 2 +e Source
  did -a $dname 2 +e List
  dll $mdx SetControlMDX $dname 5 Listview report grid infotip > $scriptdirDLLS\views.mdx
  did -i $dname 5 1 headerdims 225 52
  did -i $dname 5 1 headertext Source $chr(9) Total
  dll $mdx SetFont $dname 2,3,4,5,6,7,11,12,13,17,18,21,22,23 -10 400 $gettok($hget(system,font.style),1,32)
  dll $mdx SetBorderStyle $dname 3,4,6,7,17,18 style $hget(system,button.style)
  dll $mdx SetBorderStyle $dname 2,5,11,13 style $hget(system,border.style)
  if ( $hget(system,d.c) == on ) { pv.d.c.a }
  if ( $hget(system,t.c) == on ) { pv.t.c.a }
  if ( $hget(system,e.l.c) == on ) { pv.el.c.a }
  list.p.f
  if ( $hget(system,pic.type) == small ) { did -c jampv 22 }
  elseif ( $hget(system,pic.type) == large ) { did -c jampv 23 }
}
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;SCLICKS EVENT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
on *:dialog:pv.sv:sclick:1:{ popread 1 2 }
on *:dialog:pv.lv:sclick:1:{ popread 1 2 }
on *:dialog:jampv:sclick:*:{
  if ( $did == 2 ) {
    var %i = $branch(jampv,2)
    if ( %i == Source ) { did -f jampv 1 }
    elseif ( %i == List ) { did -f jampv 10 }
  }
  if ( $did == 3 ) { get.pv.help }
  if ( $did == 4 ) { window -c @help | pic.hash.save }
  if ( $did == 6 ) { add.p.s }
  if ( $did == 7 ) { del.p.s }
  if ( $did == 17 ) { view.p }
  if ( $did == 18 ) { p.list.f }
  if ( $did == 22 ) { hadd system pic.type small | system.update | did -c jampv 22 | did -u jampv 23 }
  if ( $did == 23 ) { hadd system pic.type large | system.update | did -c jampv 23 | did -u jampv 22 }
}
